<?

require_once 'ext/ext_helper.php';

class TorLook_Class {

    const DEBUG_IGNORE = 0;

	static $cName = 'TorLook';
	static $className = 'TorLook_Class';
	static $DomainName = null;
	static $altDomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;

    static $lang = 'ru';
    static $avoid_cyr = false;

    public static $customResolveOpts = '';

    public static $lastCurlExitCode = '';

    public static function setLang($lang)
    {
        $lang = strtolower($lang);
        self::$lang = $lang == 'ru' ? 'ru' : 'en';
        self::$avoid_cyr =
            $lang != 'ru' && $lang != 'uk' && $lang != 'kk';
    }

    public static function setDomainName($name) {
        self::$DomainName = $name;
    }

	public static function getDomainName(){
		if (null === self::$DomainName) {
			self::$DomainName =
                HD::getItemStr(self::$cName . 'DomainName') != '' ?
                 HD::getItemStr(self::$cName . 'DomainName') :
                 'https://gw1.torlook.info';
        }
		return self::$DomainName;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => '');	
		$keyword = $movie->name;
		if ($movie->name != $movie->name_original)
			$keyword = $movie->name_original;
        if ($movie->year && $movie->year > 1900)
            $keyword .= " $movie->year";
        $hurl = self::getDomainName() . "/" .
            urlencode(mb_strtolower($keyword, 'UTF-8')) . '/' .
            $sorting['vod_torrentlist'] . '?lang=' . self::$lang;
		$doc = self::http_get_document($hurl);//thx sb69 from forum.hdtv.ru

        $num_pdf_likes = 0;
        $num_soundtracks = 0;
        $num_cyr = 0;
        $total = 0;
        $begin = strpos($doc, 'webResult item">');
        while ($begin)
        {
            $end = strpos($doc, 'webResult item">', $begin + 16);
            $str = substr($doc, $begin, $end ? $end - $begin : null);
            $begin = $end;

            if (preg_match('|webResult item">.+?">(.+?)</a>.*?blank">(.+?)<.*?class="size">(.+?)<.*?"date">(.+?)<.*?up">(.+?)</span>.*?down">(.+?)</span>.*?<span class="magnet">(.*?)</span>|ms',
                    $str, $match))
            {
                $v = $match[7];
                if (preg_match('|data-src="(.*?)"|', $v, $m)){
                    $caption = HD::str_remove_tag($match[1]);
                    $size = HD::str_remove_tag($match[3]);
                    $S = HD::str_remove_tag($match[5]);
                    $L = HD::str_remove_tag($match[6]);

                    $total++;

                    if (preg_match('#\bPDF|EPUB|FB2\b#', $caption) ||
                        preg_match('#\bDjVu\b#i', $caption))
                    {
                        // TODO: revise size condition
                        $arr = explode(' ', $size);
                        if ($arr[1] != 'GB' || $arr[0] < 2.0)
                        {
                            if (self::DEBUG_IGNORE) {
                                hd_print("DEBUG ignoring pdf/epub/etc torrent by caption and size: ".
                                    "[$size, $S/$L] $caption");
                            }
                            $num_pdf_likes++;
                            continue;
                        }
                    }

                    if (preg_match('#\bsoundtrack\b#i', $caption) ||
                        preg_match('#\bflac\b#i', $caption) ||
                        preg_match('#\bmp3\b#i', $caption) ||
                        preg_match('#\bkbps\b#i', $caption))
                    {
                        if (self::DEBUG_IGNORE) {
                            hd_print("DEBUG ignoring soundtrack torrent by caption: ".
                                "[$size, $S/$L] $caption");
                        }
                        $num_soundtracks++;
                        continue;
                    }

                    if (self::$avoid_cyr && preg_match('/[\p{Cyrillic}]/u', $caption))
                    {
                        if (self::DEBUG_IGNORE)
                            hd_print("DEBUG ignoring cyrillic caption: $caption");
                        $num_cyr++;
                        continue;
                    }

                    $short_movie = new ShortMovie(
                        strval(trim($m[1])),
                        strval($caption),
                        '');

                    $short_movie->group_id =
                        TorrentHelper::get_group_id($short_movie->id);

                    $short_movie->S = intval($S);
                    $short_movie->L = intval($L);
                    $short_movie->size = $size ? $size : "0";

                    $id_arr = explode('/', $short_movie->id, 3);
                    if (count($id_arr) == 3 &&
                        $id_arr[0] == 'dl' && is_numeric($id_arr[1]))
                    { 
                        $short_movie->id2 = $id_arr[2];
                    }
                    else
                        $short_movie->id2 = $short_movie->id;

                    $short_movie->size_mb = ExtHelper::size_to_mb($size);
                    
                    $info = '||' . $caption . 
                        '|Размер: '. $size . 
                        '||S: '. $S . ' L: '. $L;
                    $short_movie->extra_item = $size . ' ('. $S . '/'. $L . ')';
                    if (preg_match('|_blank">(.+?)<|ms', $match[0], $m2))
                        $info .= '||' . $m2[1];
                    $short_movie->details_box_width = true;
                    $short_movie->info = $info;
                    array_push ($items, $short_movie);
                }
            }
        }

        $perc = sprintf("%.2f", ($num_pdf_likes + $num_soundtracks) * 100.0 / $total);
        hd_print("Torrents ignored: $num_pdf_likes documents, $num_soundtracks sountracks of total $total ($perc%)");
        if (self::$avoid_cyr) {
            $perc = sprintf("%.2f", $num_cyr * 100.0 / $total);
            hd_print("Cyr torrents ignored: $num_cyr of total $total ($perc%)");
        }
		$m_feed = 'end';
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
        $hurl = self::getDomainName() . '/' . $torrent_id;
		$doc =  self::http_get_document($hurl);
		if (preg_match("|<a href='(.*?)'|ms", $doc, $match)){
			$torrentFile["status"] = true;
			$torrentFile["path"] = $match[1];
			return $torrentFile;
		}
		return array("status" => false,"descr" => "Возможно произошла ошибка при поиске магнет ссылки");
	}
	private static function http_get_document ($url, $opts=null){

        // NOTE: this is workaround for problems with blocking when
        // accessing torlook.info.

        $opath = DuneSystem::$properties['tmp_dir_path'] . "/curl_output";
        $cmd = "/firmware/bin/curl -ksL -m 20 -o $opath ".
            self::$customResolveOpts.
            " --compressed ".
            "-A 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36' ".
            "'$url'";
        hd_print("HTTP fetch command: $cmd");

        self::$lastCurlExitCode = 0;
        $res = system($cmd, self::$lastCurlExitCode);
        if ($res === false) {
            hd_print("HTTP command returned null");
            return '';
        }
        if ($res === false) {
            hd_print("HTTP command returned false");
            return '';
        }
        $res = self::$lastCurlExitCode == 0 ? file_get_contents($opath) : '';
        hd_print("HTTP command returned bytes: ".strlen($res));
        return $res;
	}
}
