<?php

class State
{
    public $nav_mts = null;
    public $nav_all_torrents_opened = false;
    public $global_s;
    public $global_e;

    public $playstart_mts = null;
    public $play_mts = null;

    public $nav_tfs = null;
    public $playstart_tfs = null;
    public $play_tfs = null;
    public $prev_play_tfs = null;

    public $installing_ts = 0;

    public $dirty = false;

    public function enter_movie($movie_str, $lang, $region,
        $is_playing, $autostart)
    {
        $movie = json_decode($movie_str);
        if (!$movie)
            return array();

        $pname = DuneSystem::$properties['plugin_name'];
        $DPATH = "/flashdata/plugins_data/$pname/torlog";
        if (is_dir($DPATH)) {
            file_put_contents("$DPATH/$movie->id.json", $movie_str);
        }

        if ($movie->season_numbers) {
            // TODO: hack-workaround. I dont understand this, but simple
            // cast to (array) is not enough.
            $sns = array();
            foreach ($movie->season_numbers as $k => $v)
                $sns[$k] = $v;
            $movie->season_numbers = $sns;
        }

        $this->nav_tfs = null;
        $this->nav_all_torrents_opened = false;

        $dirty = $this->dirty;
        $this->dirty = false;

        if (!$dirty && $this->nav_mts &&
            $movie->id == $this->nav_mts->get_movie_id())
        {
hd_print("State D: enter_movie: reopen(0) $movie->id: $movie->title");
            $this->nav_mts->reopen($autostart);
            return $this->nav_mts->get_torrents();
        }

        if (!$this->dirty && $is_playing && $this->play_mts &&
            $movie->id == $this->play_mts->get_movie_id())
        {
hd_print("State D: enter_movie: reopen(1) $movie->id: $movie->title");
            $this->nav_mts = $this->play_mts->make_copy();
            $this->nav_mts->reopen($autostart);
            return $this->nav_mts->get_torrents();
        }

        if (!$dirty && $is_playing && $this->playstart_mts &&
            $movie->id == $this->playstart_mts->get_movie_id())
        {
hd_print("State D: enter_movie: reopen(2) $movie->id: $movie->title");
            $this->nav_mts = $this->playstart_mts->make_copy();
            $this->nav_mts->reopen($autostart);
            return $this->nav_mts->get_torrents();
        }

        $this->nav_mts = new MovieTorrents($movie, $lang, $region);
        if (!$this->nav_mts->open($autostart)) {
            $this->nav_mts = null;
            return array();
        }

        return $this->nav_mts->get_torrents();
    }

    public function enter_season($season)
    {
        $this->nav_mts->set_season($season);
        $this->nav_all_torrents_opened = false;
    }

    public function enter_episode($episode)
    {
        $this->nav_mts->set_episode($episode);
        $this->nav_all_torrents_opened = false;
    }

    public function enter_season_and_episode($season, $episode)
    {
        $this->nav_mts->set_season_and_episode($season, $episode);
        $this->nav_all_torrents_opened = false;
    }

    public function enter_all_torrents()
    {
        $this->nav_all_torrents_opened = true;
    }

    public function enter_torrent($tfs)
    {
        if (!$this->nav_mts) {
            hd_print("State.enter_torrent() E: nav_mts is null");
            return;
        }

        $tfs_mid = $tfs->get_movie_id();
        $nav_mid = $this->nav_mts->get_movie_id();
        if ($nav_mid != $tfs_mid) {
            hd_print("State.enter_torrent() E: ".
                "movie_id mismatch $nav_mid != $tfs_mid");
            return;
        }

        $this->nav_tfs = $tfs;
    }

    public function prepare_to_play_torrent()
    {
        if (!$this->nav_mts) {
            hd_print("State.prepare_to_play_torrent() E: nav_mts is null");
            return;
        }

        $this->playstart_mts = $this->nav_mts->make_copy();
        $this->play_mts = $this->nav_mts->make_copy();

        $this->prev_play_tfs = $this->play_tfs;
        $this->play_tfs = null;
    }

    public function play_torrent($tfs, $is_restart)
    {
        $mts = $is_restart ? $this->play_mts : $this->nav_mts;
        if (!$mts) {
            hd_print("State.play_torrent($is_restart) E: mts is null");
            return;
        }

        $tfs_mid = $tfs->get_movie_id();
        $play_mid = $mts->get_movie_id();
        if ($play_mid != $tfs_mid) {
            hd_print("State.play_torrent($is_restart) E: ".
                "movie id mismatch $play_mid != $tfs_mid");
            return;
        }

        if (!$is_restart) {
            $this->playstart_mts = $mts->make_copy();
            $this->play_mts = $mts->make_copy();
        }
        
        $this->prev_play_tfs = null;
        $this->play_tfs = $tfs;
        if (!$is_restart)
            $this->playstart_tfs = $tfs;

        MainHelper::$config->reload();
    }
}

?>
